#[doc = "Register `PID0` reader"]
pub struct R(crate::R<PID0_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<PID0_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<PID0_SPEC>> for R {
    fn from(reader: crate::R<PID0_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `PID0` writer"]
pub struct W(crate::W<PID0_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<PID0_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<PID0_SPEC>> for W {
    fn from(writer: crate::W<PID0_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `PN_MIN` reader - JEP106 part number. 4 lsbs of CPUSS.PARTNUMBER parameter. These part numbers are maintained in spec 40-9500."]
pub struct PN_MIN_R(crate::FieldReader<u8, u8>);
impl PN_MIN_R {
    pub(crate) fn new(bits: u8) -> Self {
        PN_MIN_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PN_MIN_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:7 - JEP106 part number. 4 lsbs of CPUSS.PARTNUMBER parameter. These part numbers are maintained in spec 40-9500."]
    #[inline(always)]
    pub fn pn_min(&self) -> PN_MIN_R {
        PN_MIN_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "Peripheral Identification Register 0.\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [pid0](index.html) module"]
pub struct PID0_SPEC;
impl crate::RegisterSpec for PID0_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [pid0::R](R) reader structure"]
impl crate::Readable for PID0_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [pid0::W](W) writer structure"]
impl crate::Writable for PID0_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets PID0 to value 0"]
impl crate::Resettable for PID0_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
